diff -purN u-boot-orig/board/mpl/common/memtst.c u-boot/board/mpl/common/memtst.c
--- u-boot-orig/board/mpl/common/memtst.c	2005-11-01 11:22:38.000000000 +0100
+++ u-boot/board/mpl/common/memtst.c	2005-11-01 11:31:15.000000000 +0100
@@ -22,28 +22,6 @@
  *
  */
 
-/* NOT Used yet...
-  add following code to PIP405.c :
-int testdram (void)
-{
-	unsigned char s[32];
-	int i;
-
-	i = getenv_r ("testmem", s, 32);
-	if (i != 0) {
-		i = (int) simple_strtoul (s, NULL, 10);
-		if ((i > 0) && (i < 0xf)) {
-			printf ("testing ");
-			i = mem_test (0, ramsize, i);
-			if (i > 0)
-				printf ("ERROR ");
-			else
-				printf ("Ok ");
-		}
-	}
-	return (1);
-}
-*/
 
 
 #include <common.h>
@@ -582,6 +560,52 @@ int mem_test (unsigned long start, unsig
 		while (prog-- > 0)
 			printf ("\b \b");
 	}
+#ifdef CONFIG_405GP
+	/* Check ECC */
+	mtdcr (memcfga, mem_ecccf);
+	i = mfdcr (memcfgd);
+	if (i) { /* ecc enabled */
+		mtdcr (memcfga, mem_eccerr);
+		i = mfdcr (memcfgd);
+		i &= 0xFFF0F000; /* mask unused bits */
+		if (i) {
+			puts ("\nERROR in ECC:\n");
+			if (i & 0xF0000000) {
+				for (prog = 0; prog < 4;prog++) {
+					/* this may be documented the wrong way:
+					 * An error on D6 causes to set the Error in lane 3
+					 * instead of lane 0
+					 * if((i&0xF0000000) & (0x10000000 << prog))
+					 */
+					if ((i & 0xF0000000) & (0x80000000 >> prog))
+						printf ("  - Even Word Lane %d\n",prog);
+				}
+			}
+			if (i & 0x0F000000) {
+				for (prog = 0; prog < 4; prog++) {
+					/* see above */
+					if ((i & 0x0F000000) & (0x08000000 >> prog))
+						printf ("  - Odd Word Lane %d\n",prog);
+				}
+			}
+			if (i & 0x00C00000) {
+				printf (" - ECC Error in %s%sCheck Bits\n",
+					(i & 0x00800000) ? "lower " : "",
+					(i & 0x00400000) ? "upper " : "");
+			}
+			if (i & 0x0000F000) {
+				for (prog = 0; prog < 4; prog++) {
+					if ((i & 0x0000F000) & (0x00008000 >> prog))
+						printf ("  - in Bank %d\n",prog);
+				}
+			}
+			status=TEST_FAILED;
+		}
+		else {
+			puts ("\nECC Bit's Ok\n");
+		}
+	}
+#endif
 
 	if (status == TEST_FAILED)
 		errors++;
